import java.util.Hashtable ;

class Piece {
	private Hashtable colourOfFace ;
		// map face -> colour

	public Piece () {
		colourOfFace = new Hashtable() ;

		// default : all sides grey :
		setColour(Face.FRONT, Colour.GREY) ;
		setColour(Face.TOP,   Colour.GREY) ;
		setColour(Face.RIGHT, Colour.GREY) ;
		setColour(Face.LEFT,  Colour.GREY) ;
		setColour(Face.DOWN,  Colour.GREY) ;
		setColour(Face.BACK,  Colour.GREY) ;
	}

	public void setColour(Face f, Colour col) {
		colourOfFace.put(f, col) ;
	}

	public Colour getColour(Face f) {
		return (Colour)colourOfFace.get(f) ;
	}

	public void rotateClockwizeAround(int axis) {
		Colour safeColour = null ;

		switch (axis) {

			case Axis.XAXIS : 	// clockwize for X axis
							safeColour = getColour(Face.TOP) ;
							setColour(Face.TOP,   getColour(Face.BACK)) ;
							setColour(Face.BACK,  getColour(Face.DOWN)) ;
							setColour(Face.DOWN,  getColour(Face.FRONT)) ;
							setColour(Face.FRONT, safeColour) ;
							break ;


			case Axis.YAXIS :		// clockwize for Y axis
							safeColour = getColour(Face.FRONT) ;
							setColour(Face.FRONT, getColour(Face.LEFT)) ;
							setColour(Face.LEFT,  getColour(Face.BACK)) ;
							setColour(Face.BACK,  getColour(Face.RIGHT)) ;
							setColour(Face.RIGHT, safeColour) ;
							break ;

			case Axis.ZAXIS :		// clockwise for Z axis
							safeColour = getColour(Face.TOP) ;
							setColour(Face.TOP,   getColour(Face.LEFT)) ;
							setColour(Face.LEFT,  getColour(Face.DOWN)) ;
							setColour(Face.DOWN,  getColour(Face.RIGHT)) ;
							setColour(Face.RIGHT, safeColour) ;
							break ;

			default : System.out.println("bug\n") ;
		}
	}

	public String toString(Face f) {
		return getColour(f).toString() ;
	}
}
