// Exercise TD1

// declaration de la classe NombreComplexe
class NombreComplexe
{
  // deux variables membres
  private double partieReelle;
  private double partieImaginaire;

  // une methode de la classe NombreComplexe qui va multiplier
  // le nombre complexe represent par l'objet courant par un nombre reel
  void multiplier(double scalaire)
  {
    partieReelle     *= scalaire;
    partieImaginaire *= scalaire;
  }

  // une methode qui va additionner le nombre complexe represent par l'objet
  // courant et un autre nombre complexe, fourni en argument
  void additionner(NombreComplexe autreNombre)
  {
    partieReelle     += autreNombre.partieReelle;
    partieImaginaire += autreNombre.partieImaginaire;
  }

  // remarquez que cette methode porte le meme nom "multiplier"
  // (elle se distingue par ses arguments)
  void multiplier(NombreComplexe autreNombre)
  {
    double safePartieReelle = partieReelle ;  
    partieReelle     =    partieReelle * autreNombre.partieReelle
                        - partieImaginaire * autreNombre.partieImaginaire;
    partieImaginaire =    safePartieReelle * autreNombre.partieImaginaire
                        + partieImaginaire * autreNombre.partieReelle;
  }

  void afficher()
  {
    // pour concatener des chaines de caracteres on utilise "+"
    System.out.println("(" + partieReelle + "," + partieImaginaire + ")");
  }

  // le constructeur, il permet d'initialiser les variables membres
  // par des valeurs passees en parametre
  NombreComplexe(double _partieReelle,double _partieImaginaire)
  {
    partieReelle     = _partieReelle;
    partieImaginaire = _partieImaginaire;
  }
}


class Test
{
  // la fonction main est appel lorsque le programme demarre
  public static void main(String args[])
  {
    // on cree deux nombres complexes, en les initialisant
    NombreComplexe nombre1 = new NombreComplexe(1,1);
    NombreComplexe nombre2 = new NombreComplexe(5,3);
    nombre1.afficher();
    nombre2.afficher();
    nombre1.multiplier(nombre2);
    nombre1.afficher();
    nombre1.multiplier(5);
    nombre1.afficher();
    // ici on passe un nombre complexe en argument de la methode "additionner"
    // en le crant a la vole
    nombre1.additionner(new NombreComplexe(2,2));
    nombre1.afficher();
  }
}
