public class Entier {
        /** Marche seulement pour les entiers positifs ou nuls.
        Inspire de la representation de entiers de Zermello.
        Les entiers sont implantes en utilisant une representation unaire.
        L'addition est definie sur ces entiers.
        **/

// *** attributes (private) :

  public static int NB_OBJECTS_CREATED = 0;    // pour analyse
                                               // de l'implantation

  private Entier prec;    // l'entier precedent


// *** public methods:


  public Entier () {
    prec = null ;
    NB_OBJECTS_CREATED++ ;
  }

  public boolean estZero() {
    return (prec == null) ;
  }

  public Entier plusUn () {
    Entier newEntier = new Entier() ;
    newEntier.prec = this ;
    return newEntier ;
  }

  public Entier moinsUn () {
    if (estZero())
    {
      System.out.println("Zero moins 1 pas possible. Je retourne null.") ;
      return null ;
    }
    else
      return prec ;
  }

  public Entier plus (Entier b) {
    if (b.estZero())
      return this ;
    else
      return (this.plusUn().plus(b.moinsUn())) ;
  }

  public static Entier creerEntier (int valeur) {
    Entier aRetourner = new Entier () ;  // cas valeur == 0
    if (valeur > 0)
      aRetourner.prec = creerEntier(valeur - 1) ;
    return aRetourner ;
  }

  public int intValue () {
    if (prec == null)
      return 0 ;
    else
      return (1 + prec.intValue()) ;
  }

  public String toString() {
    return String.valueOf(intValue()) ;
  }
}
