public class Pile {

  private Liste liste ;

  public Pile ()  {
    // cre une pile vide
    liste = new Liste() ; // creation d'une pile vide.
  }

  public void empiler(Object o)  {
    liste = liste.ajouterEnTete(o) ;
  }

  public Object depiler()  {
    Object aRetourner ;

    if (estVide())
    {
      System.out.println("Aucun objet dans la pile. Ne peut dpiler.") ;
      aRetourner = null ;
    }
    else
    {
      aRetourner = liste.tete() ;
      liste = liste.queue() ;
    }

    return aRetourner ;
  }

  public Object sommet()  {
    Object aRetourner ;

    if (estVide())
    {
      System.out.println("Aucun objet dans la pile") ;
      aRetourner = null ;
    }
    else
    {
      aRetourner = liste.tete() ;
    }

    return aRetourner ;
  }

  public int hauteur() {
    return liste.longueur() ;
  }

  public boolean estVide() {
    return (liste.estVide()) ;
  }

  public void vider() {
    liste = new Liste() ;
  }

  public void swap () { // swaps the two elements on top of stack
    if (hauteur() < 2)
    {
      System.out.println("Less than 2 elements: cannot swap.") ;
    }
    else
    {
      Object top      = depiler() ;
      Object belowTop = depiler() ;
      empiler(top) ;
      empiler(belowTop) ;
    }
  }

  public String toString() {
    String aRetourner = "" ;
    aRetourner += liste.longueur() + " lments :\n" ;

    Liste listeDeParcours = liste ;
    while (!listeDeParcours.estVide())
    {
      aRetourner += listeDeParcours.tete().toString() + "\n" ;
      listeDeParcours = listeDeParcours.queue() ;
    }

    return aRetourner ;
  }
}
