class File {

  private Liste laListe ;

  /** cree une file vide **/
  public File () {
    laListe = new Liste() ;
  }

  public boolean estVide () {
    return (laListe.estVide()) ;
  }

  public int longueur () {
    return laListe.longueur() ;
  }

  public void ajouterEnQueue (Object o) {
    laListe = laListe.ajouterEnQueue(o) ;
  }

  public Object tete () {
    if (laListe.estVide())
    {
      System.out.println("Pas d'objets dans la queue.") ;
      return null ;
    }
    else
      return laListe.tete() ;
  }

  public Object supprimerTete () {
    Object aRetourner = null ;
    if (laListe.estVide())
      System.out.println("Pas d'objets dans la queue.") ;
    else
    {
      aRetourner = laListe.tete() ;
      laListe = laListe.queue() ;
    }
    return aRetourner ;
  }

  public File simplifier () {
                        // Cas o la file courante est une file de files.
                        // (I.e., une file "en morceaux").
                        // On veut une seule file.
    File aRetourner = new File () ;
    Liste listeCourante = laListe ;
    while (!listeCourante.estVide())
    {
      aRetourner.laListe =
        aRetourner.laListe.concat(((File)listeCourante.tete()).laListe) ;
      listeCourante = listeCourante.queue() ;
    }
    return aRetourner ;
  }

  public static File mettreDAccord(Liste l) {
                        // Une liste de files.
                        // On cree une file avec la liste des premiers en tete,
                        // etc...

    // Effectuer une copie de la liste en entree
    // (et surtout des files contenues) :
    Liste listeDeTravail = new Liste() ;
    Liste listeDeParcours = l ;
    while (!listeDeParcours.estVide())
    {
      listeDeTravail =
        listeDeTravail.ajouterEnTete(((File)listeDeParcours.tete()).copie()) ;
      listeDeParcours = listeDeParcours.queue() ;
    }

    // Le travail de classement :
    File aRetourner = new File() ;
    boolean fini = false ;
    while (!fini)  // fini : lorsque toutes les files de la liste
                  // en entre sont vides.
    {
      fini = true ;  // "a priori" (default)
      // parcours de la liste : on prend les premiers,
      // et on les ote de leur file.
      listeDeParcours = listeDeTravail ;
      Liste aRajouterDansLaFile = new Liste() ;

      while(!listeDeParcours.estVide())
      {    // en prend le premier de la file, et on le met dans la liste
          // a rajouter  la file de retour.
          File laFileConsideree = (File) listeDeParcours.tete() ;
          if (!laFileConsideree.estVide())
          {
            aRajouterDansLaFile =
        aRajouterDansLaFile.ajouterEnTete(laFileConsideree.supprimerTete()) ;
          }
          if (!laFileConsideree.estVide())
            fini = false ;

          listeDeParcours = listeDeParcours.queue() ;
      }

      aRetourner.ajouterEnQueue(aRajouterDansLaFile) ;
    }

    return aRetourner ;
  }

  public File copie() {
    File aRetourner = new File() ;
    Liste listeCourante = laListe ;
    while (!listeCourante.estVide())
    {
      aRetourner.ajouterEnQueue(listeCourante.tete()) ;
      listeCourante = listeCourante.queue() ;
    }
    return aRetourner ;
  }

  public String toString () {
    String aRetourner = "" ;
    Liste listeCourante = laListe ;
    while (!listeCourante.estVide())
    {
      aRetourner += listeCourante.tete().toString() + "\n";
      listeCourante = listeCourante.queue() ;
    }
    return aRetourner ;
  }
}
