public abstract class ExpArith {
  public abstract int evaluer () ;
}


class Constante extends ExpArith {

  private int valeur ;

  public Constante(int valeur) {
    this.valeur = valeur ;
  }

  public int evaluer () {
    return valeur ;
  }

  public String toString () {
    return String.valueOf(valeur) ;
  }
}


class ExpArithUnaire extends ExpArith {

  private ExpArith membre ;
  private char op ;

  public ExpArithUnaire (char op, ExpArith membre) {
    this.membre = membre ;
    this.op = op ;
  }

  public int evaluer () {
    int aRetourner ;
    switch (op) {
      case '+' :
                aRetourner = membre.evaluer() ;
                break ;
      case '-' :
                aRetourner = - membre.evaluer() ;
                break ;
      default :
                System.out.println("Hum ! Cette operation unaire n'en est pas une !") ;
                aRetourner = 0 ;
    }
    return aRetourner ;
  }

  public String toString () {
    return (op + "(" + membre.toString() + ")") ;
  }
}


class ExpArithBinaire extends ExpArith {

  private ExpArith membreGauche ;
  private ExpArith membreDroit ;
  private char op ;

  public ExpArithBinaire (ExpArith e1, char op, ExpArith e2) {
    this.membreGauche = e1 ;
    this.membreDroit = e2 ;
    this.op = op ;
  }

  public int evaluer () {
    int aRetourner ;
    switch (op) {
      case '+' :
                aRetourner = membreGauche.evaluer() + membreDroit.evaluer() ;
                break ;
      case '-' :
                aRetourner = membreGauche.evaluer() - membreDroit.evaluer() ;
                break ;
      case '*' :
                aRetourner = membreGauche.evaluer() * membreDroit.evaluer() ;
                break ;
      default :
                System.out.println("Hum ! Cette operation binaire n'en est pas une !") ;
                aRetourner = 0 ;
    }
    return aRetourner ;
  }

  public String toString () {
    return (  "(" + membreGauche.toString() + ") "
            + op
            + " (" + membreDroit.toString() + ")") ;
  }
}
