// Pour simplifier la programmation,
// on signale le bas de la pile par une pile vide.

public class PileDeLyumines {

	Lyumine element ;
  PileDeLyumines auDessous ;

	public PileDeLyumines ()	{
		// cre une pile vide
		element   = null ;
		auDessous = null ;
	}

	public boolean estVide() {
		return ((element == null) && (auDessous == null)) ;
	}

	public void empiler(Lyumine l)	{
		PileDeLyumines nouvellePile = new PileDeLyumines() ;
		nouvellePile.element = element ;
		nouvellePile.auDessous = auDessous ;
		element = l ;
		auDessous = nouvellePile ;
	}

	public Lyumine dpiler()	{
		if (estVide())
		{
			System.out.println("Aucun lyumine dans la pile ; ne peut pas depiler.") ;
			return null ;
		}
		else
		{
			Lyumine aRetourner = element ;
			element = auDessous.element ;
			auDessous = auDessous.auDessous ;
				// ok si pile vide au-dessous : this devient une pile vide.
			return aRetourner ;
		}
	}

	public Lyumine sommet ()	{
		if (estVide())
		{
			System.out.println("Aucun luimine dans la pile ; ne peut retourner de sommet.") ;
			return null ;
		}
		else
		{
			return element ;
		}
	}

	public void vider() {
		element = null ;
		auDessous = null ;
	}

	public boolean contient (Lyumine l)	{
		if (estVide())
			return false ;
		else
		{
			return (element.equals(l) || auDessous.contient(l)) ;
		}
	}

	public int hauteur() {
		if (estVide())
			return 0 ;
		else
			return 1 + auDessous.hauteur() ;
	}

	public String toString() {
		if (estVide())
			return "" ;
		else
		{
			return (element.toString() + '\n' + auDessous.toString()) ;
		}
	}

	public PileDeLyumines copie () {
		PileDeLyumines aRetourner ;
		if (estVide())
			aRetourner = new PileDeLyumines() ;
		else
		{
			aRetourner = auDessous.copie() ;
			aRetourner.empiler(element) ;
		}
		return aRetourner ;
	}

	public void empiler(PileDeLyumines p2) {
		if (!p2.estVide())
		{
			empiler(p2.auDessous) ;
			empiler(p2.sommet()) ;
		}
	}
}
