/**
Villes.
Une ville connait toutes les routes qui partent d'elles.
**/

public class Ville {

  private String nom ;
  private Liste listeDesRoutesPartantDeThis ;

  private boolean cherchant ;
          /* utilise par la methode "estJoignable"
          pour eviter un bouclage.
          */


  public Ville (String nom) {
    this.nom = nom ;
    listeDesRoutesPartantDeThis = new Liste() ;
  }

  public void ajouterRoute(Route r) {
    listeDesRoutesPartantDeThis.ajouterEnTete(r) ;
  }

  public boolean estJoignable(Ville villeB) {
    if (cherchant)
    {
      System.out.println("Je suis a la ville : " + this + ", deja parcourue !") ;
      return false ;
    }
    else
    {
      System.out.println("Je suis a la ville : "
                        + this
                        + ", a la recherche de la ville : "
                        + villeB) ;

      if (this.equals(villeB))
      {
        System.out.println("C'est moi !");
        return true ;
      }
      else
      {
        /* Idee de l'algorithme : parcourir la liste des villes que l'on peut
        atteindre a partir de this par une route,
        et demander a ces villes si "villeB" est atteignable a partir d'elles.
        La liste est parcourue tant qu'aucune reponse positive n'est
        encore parvenue a "this". Si on a parcouru
        toute la liste sans avoir de reponse positive, la reponse
        est negative.
        */
        cherchant = true ;  // pour eviter un bouclage
        boolean atteignable = false ;
        Liste listeTemporaire = listeDesRoutesPartantDeThis ;
        Route aParcourir ;
        while ((!atteignable) && (!listeTemporaire.estVide()))
        {
          aParcourir = (Route)listeTemporaire.tete() ;
          System.out.println("De " + this + ", je parcours la route : " + aParcourir);
          atteignable = aParcourir.autreVille(this).estJoignable(villeB) ;
          listeTemporaire = listeTemporaire.queue() ;
        }
        cherchant = false ;  // liberation de l'"anti-bouclage".
        return atteignable ;
      }
    }
  }

  public String toString () {
    return nom ;
  }
}
