class Noeud {
	String element ;
	Liste listeDesConnaissances ;

	public Noeud(String nom) {
		element = nom ;
		listeDesConnaissances = new Liste() ;
	}

	public void ajouterConnaissance(String nom) {
		listeDesConnaissances = listeDesConnaissances.ajouterEnTete(nom) ;
	}

	public boolean connaissance(String nom) {
		return listeDesConnaissances.contient(nom) ;
	}

	public String toString() {
		String aRetourner = element ;
		aRetourner = aRetourner + "\n  connait :\n    "
	 		+ listeDesConnaissances.toString() + "\n" ;
		return aRetourner ;
	}
}


public class GrapheDesConnaissances {

	private Liste listeDesNoeuds ;


	public GrapheDesConnaissances () {
		listeDesNoeuds = new Liste() ;
	}

	public void ajouterNoeud(String nom) {
		if (!contient(nom))
			listeDesNoeuds = listeDesNoeuds.ajouterEnTete(new Noeud(nom)) ;
	}

	// Cherche le noeud qui contient le String l.
	// Retourne "null" si le noeud n'est pas dans le graphe.

	private Noeud trouverNoeud(String nom) {
		Liste listeCourante = listeDesNoeuds ;
		Noeud noeudCourant ;
		Noeud aRetourner = null ;
		boolean found = false ;
		while (!listeCourante.estVide() && !found)
		{
			noeudCourant = (Noeud)listeCourante.tete() ;
			if (noeudCourant.element.equals(nom))
			{
				found = true ;
				aRetourner = noeudCourant ;
			}
			listeCourante = listeCourante.queue() ;
		}
		return aRetourner ;
	}

	public boolean contient(String nom) {
		return (trouverNoeud(nom) != null) ;
	}

	public void ajouterConnaissance(String from, String to) {
		if (contient(from) && contient(to))
		{
			Noeud leNoeud = trouverNoeud(from) ;
			if (leNoeud != null)
				leNoeud.ajouterConnaissance(to) ;
		}
	}

	public boolean connaissance(String from, String to) {
		if (!contient(from))
			return false ;
		else
			return trouverNoeud(from).connaissance(to) ;
	}

	public String toString() {
		String aRetourner = "" ;
		Liste listeCourante = listeDesNoeuds ;
		while (!listeCourante.estVide())
		{
			aRetourner = aRetourner + ((Noeud)listeCourante.tete()).toString() + '\n' ;
			listeCourante = listeCourante.queue() ;
		}
		return aRetourner ;
	}
}
