import java.util.Map ;
import java.util.HashMap ;
import java.util.Set ;
import java.util.HashSet ;
import java.util.Iterator ;


public class Graphe {

  private HashMap noeuds ;

  // deux attributs utilises pour empecher un bouclage
  // de la methode "existenceChaine" :
  private  HashSet cherchant = new HashSet() ;
  private String initiateur ;

  public Graphe () {
    noeuds = new HashMap() ;
  }

  public void ajouterNoeud(String nom) {
    if (!contient(nom))
      noeuds.put(nom, new HashSet()) ;
  }

  public boolean contient(String nom) {
    return noeuds.containsKey(nom) ;
  }

  public void ajouterConnaissance(String from, String to) {
    if (contient(from) && contient(to))
      if (!connaissance(from, to))
        ((HashSet)noeuds.get(from)).add(to) ;
  }

  public boolean connaissance(String from, String to) {
    if (!contient(from))
      return false ;
    else
      return ((HashSet)noeuds.get(from)).contains(to) ;
  }

  public Set ensembleDesLyuminesRecenses () {
    return noeuds.keySet() ;
  }

  public Set ensembleDesConnaissances(String nom) {
    return (Set)noeuds.get(nom) ;
  }

  public boolean existenceChaine(String from, String to) {
    if (!contient(from) || !contient(to))
    {
      System.out.println(from + " et/ou " + to + " non recenss.") ;
      return false ;
    }

    // Recherche recursive de "to".
    // Bouclage vit avec les attributs "cherchant" et "initiateur".

    if (from.equals(to))
      return true ;

    if (cherchant.contains(from))
      return false ;

    if (cherchant.isEmpty())
      initiateur = from ;

    cherchant.add(from) ;

    // recherche en interrogeant les connaissances :
    boolean aRetourner = false ;
    boolean found = false ;
    Iterator iterConnaissances = ensembleDesConnaissances(from).iterator() ;
    while (iterConnaissances.hasNext() && !found)
      if (existenceChaine((String)iterConnaissances.next(), to))
          // l'appel rcursif
      {
        found = true ;
        aRetourner = true ;
      }

    // fin de la recherche : reinitialisation de "cherchant"
    // si la recherche est finie pour l'initiateur
    // (fin de la recursion).
    if (from.equals(initiateur))
    {
      cherchant = new HashSet() ;
      initiateur = null ;
    }

    return aRetourner ;
  }

  public String toString() {
    String aRetourner = "" ;

    aRetourner += "Lyumines recenss :\n" ;
    Iterator iterCles = ensembleDesLyuminesRecenses().iterator() ;
    while (iterCles.hasNext())
      aRetourner += "  " + (String)iterCles.next() ;

    aRetourner += "\n\nLeurs connaissances :\n" ;
    iterCles = ensembleDesLyuminesRecenses().iterator() ;
    while (iterCles.hasNext())
    {
      String leNom = (String)iterCles.next() ;
      aRetourner += "  " + leNom + " connait :" ;
      Iterator iterConnaissances = ensembleDesConnaissances(leNom).iterator() ;
      if (iterConnaissances.hasNext())
      {
        while (iterConnaissances.hasNext())
          aRetourner += "  " + (String)iterConnaissances.next() ;
      }
      else
          aRetourner += "  personne." ;

      aRetourner += "\n" ;
    }
    /*  version alternative (plus "efficace") :
    Iterator iterNoeuds = noeuds.entrySet().iterator() ;
    while (iterNoeuds.hasNext())
    {
      Map.Entry entree = (Map.Entry)iterNoeuds.next() ;
      aRetourner += "  " + (String)entree.getKey() + " connait :" ;
      Iterator iterConnaissances = ((Set)entree.getValue()).iterator() ;
      if (iterConnaissances.hasNext())
      {
        while (iterConnaissances.hasNext())
          aRetourner += "  " + (String)iterConnaissances.next() ;
      }
      else
          aRetourner += "  personne." ;

      aRetourner += "\n" ;
    }
    */
    return aRetourner ;
  }
}
