public class Ensemble {
  private Liste liste ;

  // Creation comme un ensemble vide
  public Ensemble () {
    liste = new Liste() ;
  }

  // Creation avec un element
  public Ensemble (Object o) {
    liste = new Liste(o) ;
  }

  public boolean estVide() {
    return liste.estVide() ;
  }

  public boolean contient(Object o) {
		return liste.contient(o) ;
  }

  public void ajouter(Object o) {
    if (!liste.contient(o))
      liste = liste.ajouterEnQueue(o) ;
						/* ajoute en queue, au lieu de la tete,
						a cause de l'affichage standard ; il est plus
						intuitif d'avoir les derniers elements ajoutes a la fin
						de l'enumeration.
						*/
		/* else
		{
			System.out.println(o + " deja la : pas ajoute.") ;
		}
		*/ 
  }

	public String toString() {
		String aRetourner = "{" ;
		Liste aParcourir = liste ;
		while(!aParcourir.estVide())
		{
			aRetourner += aParcourir.tete().toString() ;
			aParcourir = aParcourir.queue() ;
			if (aParcourir.longueur() >= 1)
				aRetourner += ", " ;
		}
		return (aRetourner + "}") ;
	}

	public int cardinal () {
		return liste.longueur() ;
	}


// Les mthodes facultatives :

	public Ensemble intersection(Ensemble E2) {
		Ensemble aRetourner = new Ensemble() ;
		Liste aParcourir = liste ;
		while (!aParcourir.estVide())
		{
			Object obj = aParcourir.tete() ;
			if (E2.contient(obj))
				aRetourner.ajouter(obj) ;
			aParcourir = aParcourir.queue() ;
		}
		return aRetourner ;
	}

	public Ensemble unionE(Ensemble E2) {
		Ensemble aRetourner = new Ensemble() ;
		Liste aParcourir ;
		aParcourir = liste ;
		while (!aParcourir.estVide())
		{
			aRetourner.ajouter(aParcourir.tete()) ;
			aParcourir = aParcourir.queue() ;
		}
		aParcourir = E2.liste ;
		while (!aParcourir.estVide())
		{
			aRetourner.ajouter(aParcourir.tete()) ;
			aParcourir = aParcourir.queue() ;
		}
				// utilise le fait que l'ajout n'ajoute pas si l'lment est dj prsent.
		return aRetourner ;
	}

	public boolean equals(Ensemble E2) {
		return (intersection(E2).cardinal() == unionE(E2).cardinal()) ;
	}

}
