import java.util.Iterator ;


public class OeufEnChocolat {

	private Ensemble oeufsContenus ;


	// Construit la representation de von Neumann de ii avec des oeufs en chocolat
	public static OeufEnChocolat newEntierEnChocolat(int ii) {

		OeufEnChocolat aRetourner ;

		if (ii == 0)
			aRetourner = new OeufEnChocolat() ;
		else
		{
			aRetourner = newEntierEnChocolat(ii -1) ;
			aRetourner.inclure(newEntierEnChocolat(ii - 1)) ;
		}

		return aRetourner ;
	}

	public OeufEnChocolat () {
		oeufsContenus = new Ensemble () ;
	}

	public OeufEnChocolat (OeufEnChocolat unOeuf) {
		oeufsContenus = new Ensemble (unOeuf) ;
	}

	public boolean estVide() {
		return oeufsContenus.estVide() ;
	}

	public void inclure(OeufEnChocolat unOeuf) {
		oeufsContenus.ajouter(unOeuf) ;
	}

	public int nbOeufsContenusSimple () {
		return oeufsContenus.cardinal() ;
	}

	public int nbOeufsContenus () {
		int aRetourner = 0 ;
		Iterator iter = oeufsContenus.iterator() ;
		while (iter.hasNext())
			aRetourner += 1 + ((OeufEnChocolat)iter.next()).nbOeufsContenus() ;

		return aRetourner ;
	}

	public String toString () {
		String aRetourner = "(" ;
		Iterator iter = oeufsContenus.iterator() ;
		while (iter.hasNext())
		{
			aRetourner += iter.next().toString() ;
			if (iter.hasNext())
				aRetourner += ", " ;
		}
		aRetourner += ")" ;
		return aRetourner ;
	}
}
