/** Il s'agit d'implanter les entiers en utilisant
des oeufs en chocolat.
On s'inspire du codage de von Neumann,
les oeufs en chocolat, qui peuvent en contenir d'autres,
jouant le role des ensembles.
L'oeuf simple ("vide") joue le role de l'ensemble vide.
**/

public class Entier {

	private OeufEnChocolat entierEnChocolat ;

	public Entier () {
		entierEnChocolat = new OeufEnChocolat() ;
	}

	public static Entier creerEntier(int ii) {
		Entier aRetourner = new Entier() ;
		int c ;
		for (c = ii ; c > 0 ; c--)
			aRetourner = aRetourner.plusUn() ;

		return aRetourner ;
	}

	public int intValue() {
		return entierEnChocolat.nbOeufsContenusSimple() ;
	}

	public boolean estZero () {
		return entierEnChocolat.estVide() ;
	}

	public Entier plusUn () {
	  Entier aRetourner = new Entier() ;
	  aRetourner.entierEnChocolat = this.entierEnChocolat.copie() ;
		aRetourner.entierEnChocolat.inclure(this.entierEnChocolat.copie()) ;
		return aRetourner ;
	}

	public Entier moinsUn () {
		return creerEntier(intValue() - 1) ;
	}

	public Entier plus(Entier b) {
		if (estZero())
			return b ;
		else
			return this.moinsUn().plus(b.plusUn()) ;
	}

	public String toString() {
		String aRetourner = "" ;
		aRetourner += entierEnChocolat.toString() + "\n" ;
		aRetourner += String.valueOf(intValue()) ;
		return aRetourner ;
	}
}
